    #include <Adafruit_CC3000.h>
    #include <ccspi.h>
    #include <SPI.h>
    #define Wido_IRQ   7
    #define Wido_VBAT  5
    #define Wido_CS    10
    #include "utility/debug.h"

    Adafruit_CC3000 Wido = Adafruit_CC3000(Wido_CS, Wido_IRQ, Wido_VBAT,SPI_CLOCK_DIVIDER); // disini merubah kecepatan clock

    // Tipe Security : WLAN_SEC_UNSEC, WLAN_SEC_WEP, WLAN_SEC_WPA or WLAN_SEC_WPA2
    #define WLAN_SECURITY   WLAN_SEC_WPA2
    #define WLAN_SSID       "LG"          
    #define WLAN_PASS       "lglglglglg"
    #define TCP_TIMEOUT      3000                   
    #define TOKEN  "xx"        
    #define VARIABLE_ID   "xx"

      int value_index;
      String value_string;
      String value;

    void setup(){
     
      Serial.begin(115200);
      Serial.println(F("Hello, CC3000!\n"));
      Serial.println(F("\nInisialisai CC3000 ..."));  
      
      if (!Wido.begin())
      {
        Serial.println(F("Tidak dapat menginisialisasi WiDO CC3000! Cek Wiring?"));
        while(1);
      }
      
      char *ssid = WLAN_SSID;
      
      if (!Wido.connectToAP(WLAN_SSID, WLAN_PASS, WLAN_SECURITY)) {
        Serial.println(F("Failed!"));
        while(1);
      } 
      
      Serial.println(F("Connected!"));
      
            Serial.println(F("Meminta DHCP"));
      while (!Wido.checkDHCP())
      {
        delay(100); // Memasukkan DHCP timeout!
      }
    }
    
        uint32_t ip = 0;    // Store Ubidots ip address
        float temp = 0;     // Store temporary sensor data for post
        Adafruit_CC3000_Client WidoClient;
 
 void loop(){
      static unsigned long RetryMillis = 0;
      static unsigned long uploadtStamp = 0;
      static unsigned long sensortStamp = 0;
      
      if(!WidoClient.connected() && millis() - RetryMillis > TCP_TIMEOUT){
        RetryMillis = millis();

        Serial.println(F("Trying to connect to Ubidots..."));

        // Connect to Ubidots 
        ip = Wido.IP2U32(50,23,124,68);               
        WidoClient = Wido.connectTCP(ip, 80);         
        Serial.println(F("Successfully connected to Ubidots."));
      }  

      if(WidoClient.connected() && millis() - uploadtStamp > 1000){
        uploadtStamp = millis();    
//   
      int length = 0;
      char lengthstr[5];
      String response = "";


      //Make an HTTP request to the Ubidots server
      Serial.print(F("Sending Http Request..."));
      WidoClient.fastrprint(F("GET /api/v1.6/variables/"));
      WidoClient.fastrprint(VARIABLE_ID);
      WidoClient.fastrprint(F("/values/?page_size=1&token="));
      WidoClient.fastrprint(TOKEN);
      WidoClient.fastrprintln(F(" HTTP/1.1"));
      WidoClient.fastrprintln(F("Content-Type: application/json"));
      WidoClient.fastrprint(F("Host: things.ubidots.com"));
      WidoClient.fastrprint("Host: things.ubidots.com");
      Serial.println(F("Done....."));
    
//
        unsigned long rTimer = millis();
        Serial.println(F("Reading Cloud Response...\r\n"));
        while (millis() - rTimer < 2000) {
          while (WidoClient.connected() && WidoClient.available()) {
            char c = WidoClient.read();
            Serial.print(c);
          }
        } 
        delay(1000); 
        WidoClient.close();
        RetryMillis = millis();
      }
 }

    
